Index: drivers/filesystems/btrfs/free-space.c
===================================================================
--- drivers/filesystems/btrfs/free-space.c	(révision 75772)
+++ drivers/filesystems/btrfs/free-space.c	(copie de travail)
@@ -1149,150 +1418,150 @@
             ERR("out of memory\n");
             return;
         }
-        
+
         s->address = address;
         s->size = length;
         InsertTailList(list, &s->list_entry);
-        
+
         if (list_size)
             InsertTailList(list_size, &s->list_entry_size);
-        
+
         if (rollback)
-            add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, length, c);
-        
+            add_rollback_space(rollback, TRUE, list, list_size, address, length, c);
+
         return;
     }
-    
+
     le = list->Flink;
-    while (le != list) {
+    do {
         s2 = CONTAINING_RECORD(le, space, list_entry);
-        
+
         // old entry envelops new one completely
         if (s2->address <= address && s2->address + s2->size >= address + length)
             return;
-        
+
         // new entry envelops old one completely
         if (address <= s2->address && address + length >= s2->address + s2->size) {
             if (address < s2->address) {
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, s2->address - address, c);
-                
+                    add_rollback_space(rollback, TRUE, list, list_size, address, s2->address - address, c);
+
                 s2->size += s2->address - address;
                 s2->address = address;
-                
+
                 while (s2->list_entry.Blink != list) {
                     space* s3 = CONTAINING_RECORD(s2->list_entry.Blink, space, list_entry);
-                    
+
                     if (s3->address + s3->size == s2->address) {
                         s2->address = s3->address;
                         s2->size += s3->size;
-                        
+
                         RemoveEntryList(&s3->list_entry);
-                        
+
                         if (list_size)
                             RemoveEntryList(&s3->list_entry_size);
-                        
+
                         ExFreePool(s3);
                     } else
                         break;
                 }
             }
-            
+
             if (length > s2->size) {
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, TRUE, list, list_size, s2->address + s2->size, address + length - s2->address - s2->size, c);
-                
+                    add_rollback_space(rollback, TRUE, list, list_size, s2->address + s2->size, address + length - s2->address - s2->size, c);
+
                 s2->size = length;
-                
+
                 while (s2->list_entry.Flink != list) {
                     space* s3 = CONTAINING_RECORD(s2->list_entry.Flink, space, list_entry);
-                    
+
                     if (s3->address <= s2->address + s2->size) {
                         s2->size = max(s2->size, s3->address + s3->size - s2->address);
-                        
+
                         RemoveEntryList(&s3->list_entry);
-                        
+
                         if (list_size)
                             RemoveEntryList(&s3->list_entry_size);
-                        
+
                         ExFreePool(s3);
                     } else
                         break;
                 }
             }
-            
+
             if (list_size) {
                 RemoveEntryList(&s2->list_entry_size);
                 order_space_entry(s2, list_size);
             }
-            
+
             return;
         }
-        
+
         // new entry overlaps start of old one
         if (address < s2->address && address + length >= s2->address) {
             if (rollback)
-                add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, s2->address - address, c);
-            
+                add_rollback_space(rollback, TRUE, list, list_size, address, s2->address - address, c);
+
             s2->size += s2->address - address;
             s2->address = address;
-            
+
             while (s2->list_entry.Blink != list) {
                 space* s3 = CONTAINING_RECORD(s2->list_entry.Blink, space, list_entry);
-                
+
                 if (s3->address + s3->size == s2->address) {
                     s2->address = s3->address;
                     s2->size += s3->size;
-                    
+
                     RemoveEntryList(&s3->list_entry);
-                    
+
                     if (list_size)
                         RemoveEntryList(&s3->list_entry_size);
-                    
+
                     ExFreePool(s3);
                 } else
                     break;
             }
-            
+
             if (list_size) {
                 RemoveEntryList(&s2->list_entry_size);
                 order_space_entry(s2, list_size);
             }
-            
+
             return;
         }
-        
+
         // new entry overlaps end of old one
         if (address <= s2->address + s2->size && address + length > s2->address + s2->size) {
             if (rollback)
-                add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, s2->address + s2->size - address, c);
-            
+                add_rollback_space(rollback, TRUE, list, list_size, address, s2->address + s2->size - address, c);
+
             s2->size = address + length - s2->address;
-            
+
             while (s2->list_entry.Flink != list) {
                 space* s3 = CONTAINING_RECORD(s2->list_entry.Flink, space, list_entry);
-                
+
                 if (s3->address <= s2->address + s2->size) {
                     s2->size = max(s2->size, s3->address + s3->size - s2->address);
-                    
+
                     RemoveEntryList(&s3->list_entry);
-                    
+
                     if (list_size)
                         RemoveEntryList(&s3->list_entry_size);
-                    
+
                     ExFreePool(s3);
                 } else
                     break;
             }
-            
+
             if (list_size) {
                 RemoveEntryList(&s2->list_entry_size);
                 order_space_entry(s2, list_size);
             }
-            
+
             return;
         }
-        
+
         // add completely separate entry
         if (s2->address > address + length) {
             s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
@@ -1301,35 +1570,35 @@
                 ERR("out of memory\n");
                 return;
             }
-            
+
             if (rollback)
-                add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, length, c);
-            
+                add_rollback_space(rollback, TRUE, list, list_size, address, length, c);
+
             s->address = address;
             s->size = length;
             InsertHeadList(s2->list_entry.Blink, &s->list_entry);
-            
+
             if (list_size)
                 order_space_entry(s, list_size);
-            
+
             return;
         }
-        
+
         le = le->Flink;
-    }
-    
+    } while (le != list);
+
     // check if contiguous with last entry
     if (s2->address + s2->size == address) {
         s2->size += length;
-        
+
         if (list_size) {
             RemoveEntryList(&s2->list_entry_size);
             order_space_entry(s2, list_size);
         }
-        
+
         return;
     }
-    
+
     // otherwise, insert at end
     s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
 
@@ -1337,28 +1606,28 @@
         ERR("out of memory\n");
         return;
     }
-    
+
     s->address = address;
     s->size = length;
     InsertTailList(list, &s->list_entry);
-    
+
     if (list_size)
         order_space_entry(s, list_size);
-    
+
     if (rollback)
-        add_rollback_space(Vcb, rollback, TRUE, list, list_size, address, length, c);
+        add_rollback_space(rollback, TRUE, list, list_size, address, length, c);
 }
 
-static void space_list_merge(device_extension* Vcb, LIST_ENTRY* spacelist, LIST_ENTRY* spacelist_size, LIST_ENTRY* deleting) {
+static void space_list_merge(LIST_ENTRY* spacelist, LIST_ENTRY* spacelist_size, LIST_ENTRY* deleting) {
     LIST_ENTRY* le;
-    
+
     if (!IsListEmpty(deleting)) {
         le = deleting->Flink;
         while (le != deleting) {
             space* s = CONTAINING_RECORD(le, space, list_entry);
-            
-            space_list_add2(Vcb, spacelist, spacelist_size, s->address, s->size, NULL);
-            
+
+            space_list_add2(spacelist, spacelist_size, s->address, s->size, NULL, NULL);
+
             le = le->Flink;
         }
     }
@@ -1370,92 +1639,99 @@
     traverse_ptr tp;
     FREE_SPACE_ITEM* fsi;
     void* data;
-    FREE_SPACE_ENTRY* fse;
-    UINT64 num_entries, num_sectors, *cachegen, i, off;
-    UINT32* checksums;
+    UINT64 num_entries, *cachegen, off;
+    UINT32 *checksums, num_sectors, i;
     LIST_ENTRY* le;
-    
-    space_list_merge(Vcb, &c->space, &c->space_size, &c->deleting);
-    
-    data = ExAllocatePoolWithTag(NonPagedPool, c->cache->inode_item.st_size, ALLOC_TAG);
+
+    space_list_merge(&c->space, &c->space_size, &c->deleting);
+
+    data = ExAllocatePoolWithTag(NonPagedPool, (ULONG)c->cache->inode_item.st_size, ALLOC_TAG);
     if (!data) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    RtlZeroMemory(data, c->cache->inode_item.st_size);
-    
+
+    RtlZeroMemory(data, (ULONG)c->cache->inode_item.st_size);
+
     num_entries = 0;
-    num_sectors = c->cache->inode_item.st_size / Vcb->superblock.sector_size;
+    num_sectors = (UINT32)(c->cache->inode_item.st_size / Vcb->superblock.sector_size);
     off = (sizeof(UINT32) * num_sectors) + sizeof(UINT64);
-    
+
     le = c->space.Flink;
     while (le != &c->space) {
+        FREE_SPACE_ENTRY* fse;
+
         space* s = CONTAINING_RECORD(le, space, list_entry);
 
         if ((off + sizeof(FREE_SPACE_ENTRY)) / Vcb->superblock.sector_size != off / Vcb->superblock.sector_size)
             off = sector_align(off, Vcb->superblock.sector_size);
-        
+
         fse = (FREE_SPACE_ENTRY*)((UINT8*)data + off);
-        
+
         fse->offset = s->address;
         fse->size = s->size;
         fse->type = FREE_SPACE_EXTENT;
         num_entries++;
-        
+
         off += sizeof(FREE_SPACE_ENTRY);
-        
+
         le = le->Flink;
     }
 
     // update INODE_ITEM
-    
+
     c->cache->inode_item.generation = Vcb->superblock.generation;
     c->cache->inode_item.transid = Vcb->superblock.generation;
     c->cache->inode_item.sequence++;
     c->cache->inode_item.st_ctime = *now;
-    
-    flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
-    
+
+    Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("flush_fcb returned %08x\n", Status);
+        goto end;
+    }
+
     // update free_space item
-    
+
     searchkey.obj_id = FREE_SPACE_CACHE_ID;
     searchkey.obj_type = 0;
     searchkey.offset = c->offset;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
-        return Status;
+        goto end;
     }
-    
+
     if (keycmp(searchkey, tp.item->key)) {
         ERR("could not find (%llx,%x,%llx) in root_root\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
-        return STATUS_INTERNAL_ERROR;
+        Status = STATUS_INTERNAL_ERROR;
+        goto end;
     }
-    
+
     if (tp.item->size < sizeof(FREE_SPACE_ITEM)) {
         ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(FREE_SPACE_ITEM));
-        return STATUS_INTERNAL_ERROR;
+        Status = STATUS_INTERNAL_ERROR;
+        goto end;
     }
-    
+
     fsi = (FREE_SPACE_ITEM*)tp.item->data;
-    
+
     fsi->generation = Vcb->superblock.generation;
     fsi->num_entries = num_entries;
     fsi->num_bitmaps = 0;
-    
+
     // set cache generation
-    
+
     cachegen = (UINT64*)((UINT8*)data + (sizeof(UINT32) * num_sectors));
     *cachegen = Vcb->superblock.generation;
-    
+
     // calculate cache checksums
-    
+
     checksums = (UINT32*)data;
-    
+
     // FIXME - if we know sector is fully zeroed, use cached checksum
-    
+
     for (i = 0; i < num_sectors; i++) {
         if (i * Vcb->superblock.sector_size > sizeof(UINT32) * num_sectors)
             checksums[i] = ~calc_crc32c(0xffffffff, (UINT8*)data + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
@@ -1464,100 +1740,228 @@
         else
             checksums[i] = ~calc_crc32c(0xffffffff, (UINT8*)data + (sizeof(UINT32) * num_sectors), ((i + 1) * Vcb->superblock.sector_size) - (sizeof(UINT32) * num_sectors));
     }
-    
+
     // write cache
-    
-    Status = do_write_file(c->cache, 0, c->cache->inode_item.st_size, data, NULL, rollback);
+
+    Status = do_write_file(c->cache, 0, c->cache->inode_item.st_size, data, NULL, FALSE, 0, rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("do_write_file returned %08x\n", Status);
+
+        // Writing the cache isn't critical, so we don't return an error if writing fails. This means
+        // we can still flush on a degraded mount if metadata is RAID1 but data is RAID0.
+    }
+
+    Status = STATUS_SUCCESS;
+
+end:
+    ExFreePool(data);
+
+    return Status;
+}
+
+static NTSTATUS update_chunk_cache_tree(device_extension* Vcb, chunk* c, LIST_ENTRY* batchlist) {
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+    FREE_SPACE_INFO* fsi;
+
+    fsi = ExAllocatePoolWithTag(PagedPool, sizeof(FREE_SPACE_INFO), ALLOC_TAG);
+    if (!fsi) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
+    space_list_merge(&c->space, &c->space_size, &c->deleting);
+
+    fsi->count = 0;
+    fsi->flags = 0;
+
+    le = c->space.Flink;
+    while (le != &c->space) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+
+        fsi->count++;
+
+        Status = insert_tree_item_batch(batchlist, Vcb, Vcb->space_root, s->address, TYPE_FREE_SPACE_EXTENT, s->size,
+                                        NULL, 0, Batch_Insert);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            ExFreePool(fsi);
+            return Status;
+        }
+
+        le = le->Flink;
+    }
+
+    Status = insert_tree_item_batch(batchlist, Vcb, Vcb->space_root, c->offset, TYPE_FREE_SPACE_INFO, c->chunk_item->size,
+                                    NULL, 0, Batch_DeleteFreeSpace);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item_batch returned %08x\n", Status);
+        ExFreePool(fsi);
         return Status;
     }
 
-    ExFreePool(data);
-    
+    Status = insert_tree_item_batch(batchlist, Vcb, Vcb->space_root, c->offset, TYPE_FREE_SPACE_INFO, c->chunk_item->size,
+                                    fsi, sizeof(FREE_SPACE_INFO), Batch_Insert);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item_batch returned %08x\n", Status);
+        ExFreePool(fsi);
+        return Status;
+    }
+
     return STATUS_SUCCESS;
 }
 
 NTSTATUS update_chunk_caches(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
-    LIST_ENTRY *le = Vcb->chunks_changed.Flink, batchlist;
+    LIST_ENTRY *le, batchlist;
     NTSTATUS Status;
     chunk* c;
     LARGE_INTEGER time;
     BTRFS_TIME now;
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     InitializeListHead(&batchlist);
-    
-    while (le != &Vcb->chunks_changed) {
-        c = CONTAINING_RECORD(le, chunk, list_entry_changed);
-        
-        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        Status = update_chunk_cache(Vcb, c, &now, &batchlist, Irp, rollback);
-        ExReleaseResourceLite(&c->lock);
 
-        if (!NT_SUCCESS(Status)) {
-            ERR("update_chunk_cache(%llx) returned %08x\n", c->offset, Status);
-            clear_batch_list(Vcb, &batchlist);
-            return Status;
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (c->space_changed) {
+            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+            Status = update_chunk_cache(Vcb, c, &now, &batchlist, Irp, rollback);
+            ExReleaseResourceLite(&c->lock);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("update_chunk_cache(%llx) returned %08x\n", c->offset, Status);
+                clear_batch_list(Vcb, &batchlist);
+                return Status;
+            }
         }
-        
+
         le = le->Flink;
     }
-    
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
-    
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        return Status;
+    }
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (c->changed && (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)) {
+            ExAcquireResourceExclusiveLite(&c->partial_stripes_lock, TRUE);
+
+            while (!IsListEmpty(&c->partial_stripes)) {
+                partial_stripe* ps = CONTAINING_RECORD(RemoveHeadList(&c->partial_stripes), partial_stripe, list_entry);
+
+                Status = flush_partial_stripe(Vcb, c, ps);
+
+                if (ps->bmparr)
+                    ExFreePool(ps->bmparr);
+
+                ExFreePool(ps);
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("flush_partial_stripe returned %08x\n", Status);
+                    ExReleaseResourceLite(&c->partial_stripes_lock);
+                    return Status;
+                }
+            }
+
+            ExReleaseResourceLite(&c->partial_stripes_lock);
+        }
+
+        le = le->Flink;
+    }
+
     return STATUS_SUCCESS;
 }
 
-void _space_list_add(device_extension* Vcb, chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback, const char* func) {
-    LIST_ENTRY* list;
-    
-    TRACE("(%p, %p, %u, %llx, %llx, %p)\n", Vcb, c, deleting, address, length, rollback);
-    
-    list = deleting ? &c->deleting : &c->space;
-    
-    if (!c->list_entry_changed.Flink)
-        InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
-    
-    _space_list_add2(Vcb, list, deleting ? NULL : &c->space_size, address, length, c, rollback, func);
+NTSTATUS update_chunk_caches_tree(device_extension* Vcb, PIRP Irp) {
+    LIST_ENTRY *le, batchlist;
+    NTSTATUS Status;
+    chunk* c;
+
+    Vcb->superblock.compat_ro_flags |= BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE_VALID;
+
+    InitializeListHead(&batchlist);
+
+    ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (c->space_changed) {
+            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+            Status = update_chunk_cache_tree(Vcb, c, &batchlist);
+            ExReleaseResourceLite(&c->lock);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("update_chunk_cache_tree(%llx) returned %08x\n", c->offset, Status);
+                ExReleaseResourceLite(&Vcb->chunk_lock);
+                clear_batch_list(Vcb, &batchlist);
+                return Status;
+            }
+        }
+
+        le = le->Flink;
+    }
+
+    ExReleaseResourceLite(&Vcb->chunk_lock);
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        return Status;
+    }
+
+    return STATUS_SUCCESS;
 }
 
-void _space_list_subtract2(device_extension* Vcb, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback, const char* func) {
+void space_list_add(chunk* c, UINT64 address, UINT64 length, LIST_ENTRY* rollback) {
+    TRACE("(%p, %llx, %llx, %p)\n", c, address, length, rollback);
+
+    c->changed = TRUE;
+    c->space_changed = TRUE;
+
+    space_list_add2(&c->deleting, NULL, address, length, c, rollback);
+}
+
+void space_list_subtract2(LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback) {
     LIST_ENTRY *le, *le2;
     space *s, *s2;
-    
-#ifdef DEBUG_SPACE_LISTS
-    _debug_message(func, "called space_list_subtract (%p, %llx, %llx, %p)\n", list, address, length, rollback);
-#endif
-    
+
     if (IsListEmpty(list))
         return;
-    
+
     le = list->Flink;
     while (le != list) {
         s2 = CONTAINING_RECORD(le, space, list_entry);
         le2 = le->Flink;
-        
+
         if (s2->address >= address + length)
             return;
-        
+
         if (s2->address >= address && s2->address + s2->size <= address + length) { // remove entry entirely
             if (rollback)
-                add_rollback_space(Vcb, rollback, FALSE, list, list_size, s2->address, s2->size, c);
-            
+                add_rollback_space(rollback, FALSE, list, list_size, s2->address, s2->size, c);
+
             RemoveEntryList(&s2->list_entry);
-            
+
             if (list_size)
                 RemoveEntryList(&s2->list_entry_size);
-            
+
             ExFreePool(s2);
         } else if (address + length > s2->address && address + length < s2->address + s2->size) {
             if (address > s2->address) { // cut out hole
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, FALSE, list, list_size, address, length, c);
-                
+                    add_rollback_space(rollback, FALSE, list, list_size, address, length, c);
+
                 s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
 
                 if (!s) {
@@ -1564,28 +1968,28 @@
                     ERR("out of memory\n");
                     return;
                 }
-                
+
                 s->address = s2->address;
                 s->size = address - s2->address;
                 InsertHeadList(s2->list_entry.Blink, &s->list_entry);
-                
+
                 s2->size = s2->address + s2->size - address - length;
                 s2->address = address + length;
-                
+
                 if (list_size) {
                     RemoveEntryList(&s2->list_entry_size);
                     order_space_entry(s2, list_size);
                     order_space_entry(s, list_size);
                 }
-                
+
                 return;
             } else { // remove start of entry
                 if (rollback)
-                    add_rollback_space(Vcb, rollback, FALSE, list, list_size, s2->address, address + length - s2->address, c);
-                
+                    add_rollback_space(rollback, FALSE, list, list_size, s2->address, address + length - s2->address, c);
+
                 s2->size -= address + length - s2->address;
                 s2->address = address + length;
-                
+
                 if (list_size) {
                     RemoveEntryList(&s2->list_entry_size);
                     order_space_entry(s2, list_size);
@@ -1593,27 +1997,27 @@
             }
         } else if (address > s2->address && address < s2->address + s2->size) { // remove end of entry
             if (rollback)
-                add_rollback_space(Vcb, rollback, FALSE, list, list_size, address, s2->address + s2->size - address, c);
-            
+                add_rollback_space(rollback, FALSE, list, list_size, address, s2->address + s2->size - address, c);
+
             s2->size = address - s2->address;
-            
+
             if (list_size) {
                 RemoveEntryList(&s2->list_entry_size);
                 order_space_entry(s2, list_size);
             }
         }
-        
+
         le = le2;
     }
 }
 
-void _space_list_subtract(device_extension* Vcb, chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback, const char* func) {
+void space_list_subtract(chunk* c, BOOL deleting, UINT64 address, UINT64 length, LIST_ENTRY* rollback) {
     LIST_ENTRY* list;
-    
+
     list = deleting ? &c->deleting : &c->space;
-    
-    if (!c->list_entry_changed.Flink)
-        InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
-    
-    _space_list_subtract2(Vcb, list, deleting ? NULL : &c->space_size, address, length, c, rollback, func);
+
+    c->changed = TRUE;
+    c->space_changed = TRUE;
+
+    space_list_subtract2(list, deleting ? NULL : &c->space_size, address, length, c, rollback);
 }
